import numpy as np

def encode(seq):
  #  print("length seq", len(seq))
    encoded_seq = np.zeros(len(seq)*4,int)
    for j in range(len(seq)):
        if seq[j] == 'A' or seq[j] == 'a':
            encoded_seq[j*4] = 1
            encoded_seq[j*4+1] = 0
            encoded_seq[j*4+2] = 0
            encoded_seq[j*4+3] = 0

        elif seq[j] == 'C' or seq[j] == 'c':
            encoded_seq[j*4] = 0
            encoded_seq[j*4+1] = 1
            encoded_seq[j*4+2] = 0
            encoded_seq[j*4+3] = 0

        elif seq[j] == 'G' or seq[j] == 'g':
            encoded_seq[j*4] = 0
            encoded_seq[j*4+1] = 0
            encoded_seq[j*4+2] = 1
            encoded_seq[j*4+3] = 0

        elif seq[j] == 'T' or seq[j] == 't':
            encoded_seq[j*4] = 0
            encoded_seq[j*4+1] = 0
            encoded_seq[j*4+2] = 0
            encoded_seq[j*4+3] = 1

        else:
            encoded_seq[j*4] = 0
            encoded_seq[j*4+1] = 0
            encoded_seq[j*4+2] = 0
            encoded_seq[j*4+3] = 0
        #    print(seq[j])

    return encoded_seq

def encode_seq(data, in_path=''):

    encoded_seq = []
    print('Starting DNA seq encoding')
    i = -1
    for line in data: 
        i += 1
        line = line.rstrip()
        """
        if line[0] == '>':
            print("header")
        elif line[0] != '>':
            element = encode(line)
            encoded_seq = np.concatenate((encoded_seq, element), axis=None)
        """
        if line:
            if i == 0:
                encoded_seq = encode(line)
                dim = encoded_seq.shape
            else:
                element = encode(line)
             #   print(encoded_seq.shape)
                if element.shape == dim:
                    encoded_seq = np.vstack((encoded_seq, element))
                
                 
    return encoded_seq 
